/* Copyright (C) 2000-2015 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#ifndef _UDM_SYNONYM_H
#define _UDM_SYNONYM_H

void UdmSynonymListInit(UDM_SYNONYMLIST * List);
UDM_API(udm_rc_t) UdmSynonymListLoad(UDM_ENV * Env,const char * filename);
void UdmSynonymListFree(UDM_SYNONYMLIST * List);
UDM_API(void) UdmSynonymListSort(UDM_SYNONYMLIST * List);

void UdmSynonymListListInit(UDM_SYNONYMLISTLIST *L);
void UdmSynonymListListFree(UDM_SYNONYMLISTLIST *L);
udm_rc_t UdmSynonymListListAdd(UDM_SYNONYMLISTLIST *L, UDM_SYNONYMLIST *I);
UDM_WIDEWORDLIST *UdmSynonymListListFind(const UDM_SYNONYMLISTLIST *List,
                                         UDM_WIDEWORD *wword);
UDM_WIDEWORDLIST *UdmSynonymListFind(UDM_WIDEWORDLIST *Res,
                                     const UDM_SYNONYMLIST *List,
                                     const UDM_WIDEWORD *wword);
UDM_API(void) UdmSynonymListListSortItems(UDM_SYNONYMLISTLIST * List);

size_t UdmMultiWordPhraseLength(const char *word);

#endif
